Subject: [PATCH 2/2] ARM: KVM: user_mem_abort: support stage 2 MMIO page mapping

From: [email-masked] (Will Deacon)
Date: Tue, 24 Jun 2014 11:23:27 +0100

On Wed, May 07, 2014 at 03:55:57PM +0100, Christoffer Dall wrote:
> On Wed, May 07, 2014 at 10:00:21AM +0100, Marc Zyngier wrote:
> > On Tue, May 06 2014 at  7:04:48 pm BST, Christoffer Dall <[email-masked]> wrote:
> > > On Tue, Mar 25, 2014 at 05:08:14PM -0500, Kim Phillips wrote:
> > >> Use the correct memory type for device MMIO mappings: PAGE_S2_DEVICE.
> > >> 
> > >> Signed-off-by: Kim Phillips <[email-masked]>
> > >> ---
> > >>  arch/arm/kvm/mmu.c | 11 ++++++++---
> > >>  1 file changed, 8 insertions(+), 3 deletions(-)

[...]

> > > I think this looks reasonable.
> > >
> > > Acked-by: Christoffer Dall <[email-masked]>
> > 
> > I feel like I'm missing some context here, and the commit message is way
> > too terse for me to make sense of it.
> > 
> > So far, we can only get into user_mem_abort on a Stage-2 fault
> > (translation or permission) for memory. How can we suddenly get here for
> > a *device* fault? Do we get a special kind of memslot?
> > 
> > I'm not saying the patch does anything wrong, but I'd like to understand
> > the rationale behind it. On its own, it doesn't make much sense.
> > 
> Think device passthrough.  There's nothing preventing user space from
> setting up a memory region to point to device memory (through VFIO or
> /dev/mem).  If that's done, we should enforce device memory properties
> so writes don't linger around in the cache to be written some time later
> when that device memory potentially doesn't belong to the VM anymore.
> 
> This is just one tiny piece of all of them to make device passthrough
> work, and we could hold off with this patch until we have something more
> complete.  On the other hand, we need to start somewhere, and this is
> hardly intrusive and is functionally correct even though you don't have
> a full device passthrough setup.

Please can you queue this patch up? I need it for my VFIO work, where I'm
registering the PCI BARs using KVM_SET_USER_MEMORY_REGION.

Without this, I'd have to trap all accesses and do pread/pwrite from
kvmtool instead of mmaping the regions straight through.

Cheers,

Will